{{ define "main" }}
<!-- homepage range in all posts -->
{{ $paginator := .Paginate (where .Site.RegularPages "Type" "in" .Site.Params.mainSections) 6  }}
{{ range $paginator.Pages }}
<div class="post">
    <h2 class="post-title">
        <a href="{{ .Permalink }}">{{ .Title }}</a>
    </h2>
    <div class="post-meta link-alter">
        {{ partial "post-meta.html" . }}
    </div>
    <div class="post-summary markdown-body">
        {{ .Summary }}
    </div>

    <div class="post-read-more"><a href="{{ .Permalink }}">Read More</a></div>
</div>
{{ end }}
<!-- custom smart pagination -->
{{ $offsetLinks := 2 }}
{{ $maxLinks := (add (mul $offsetLinks 2) 1) }}
{{ $lowerLimit := (add $offsetLinks 1) }}
{{ $upperLimit := (sub $paginator.TotalPages $offsetLinks) }}
{{ if gt $paginator.TotalPages 1 }}
<ul class="pagination">
    {{ if ne $paginator.PageNumber 1 }}
    <li class="pag-first">
        <a href="{{ $paginator.First.URL }}" aria-label="First page"><i class="icon-angle-double-left"></i></a>
    </li>
    {{ end }}
    {{ if $paginator.HasPrev }}
	<link rel="prev" href="{{ $paginator.Prev.URL | absURL }}" />
    <li class="pag-previous">
        <a href="{{ $paginator.Prev.URL }}" aria-label="Previous page"><i class="icon-angle-left"></i></a>
    </li>
    {{ end }}
    {{ range $paginator.Pagers }}
    {{ $.Scratch.Set "pageNumFlag" false }}
    {{ if gt $paginator.TotalPages $maxLinks }}
    {{ if le $paginator.PageNumber $lowerLimit }}
    {{ if le .PageNumber $maxLinks }}
    {{ $.Scratch.Set "pageNumFlag" true }}
    {{ end }}
    {{ else if ge $paginator.PageNumber $upperLimit }}
    {{ if gt .PageNumber (sub $paginator.TotalPages $maxLinks) }}
    {{ $.Scratch.Set "pageNumFlag" true }}
    {{ end }}
    {{ else }}
    {{ if and ( ge .PageNumber (sub $paginator.PageNumber $offsetLinks) ) ( le .PageNumber (add $paginator.PageNumber $offsetLinks) ) }}
    {{ $.Scratch.Set "pageNumFlag" true }}
    {{ end }}
    {{ end }}
    {{ else }}
    {{ $.Scratch.Set "pageNumFlag" true }}
    {{ end }}
    {{ if eq ($.Scratch.Get "pageNumFlag") true }}
    <li class="pag-item{{ if eq . $paginator }} pag-current{{ end }}">
        <a href="{{ .URL }}">{{ .PageNumber }}</a>
    </li>
    {{ end }}
    {{ end }}
    {{ if $paginator.HasNext }}
	<link rel="next" href="{{ $paginator.Next.URL | absURL }}" />
    <li class="pag-next">
        <a href="{{ $paginator.Next.URL }}" aria-label="Next page"><i class="icon-angle-right"></i></a>
    </li>
    {{ end }}
    {{ if ne $paginator.PageNumber $paginator.TotalPages }}
    <li class="pag-last">
        <a href="{{ $paginator.Last.URL }}" aria-label="Last page"><i class="icon-angle-double-right"></i></a>
    </li>
    {{ end }}
</ul>
{{ end }}
{{ end }}
